/***************************************************************************
 *   Copyright (C) 2007 by Artur Szymiec                                   *
 *   artur.szymiec@gmail.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************
 *                      Orginal Code & Idea by                             *
 *                          Thomas John                                    *
 *                      thomas.john@open-design.be                         *
 *                                                                         *
 *                Linux Port & Some Minor Changes by                       *
 *                         Artur Szymiec                                   *
 *                   artur.szymiec@gmail.com	                           *
 ***************************************************************************/

#ifndef EFFET_PARTICULE_H
#define EFFET_PARTICULE_H
#include "structures.h"
#include "vector3f.h"
/**
	@author Artur Szymiec <artur.szymiec@gmail.com>
*/
class effet_particule{
// private components of the class (variables, fonctions...)
		private:
			
			// structure that contain information about particles
			struct particules {
				// coordinates
				double x;
				double y;
				double z;
				// speed
				double vitesse;
				// direction
				double d_x;
				double d_y;
				double d_z;
				// age
				double vie;
				//size
				double taille;
				// colour
				double r;
				double g;
				double b;
			};

			//Declaration of variable that will hold our structure
			particules* t_particules;

			// function that will initialize our particle
			void init_particule( int particulesz );

			// structure that will hold general informations
			infos_gen * infos_tex_tmp;
			//iterate variable
			int i;
			//matrix for calculations
			float mat[16];
			//vectors
			 vector3f vPoint0;
			vector3f vPoint1;
			vector3f vPoint2;
			vector3f vPoint3;
			vector3f vCenter;
			vector3f vRight;
			vector3f vUp;
		// public members
		public:
			
			// state of the class
			int etat;

			// cordinates (x, y, z)
			double m_x;
			double m_y;
			double m_z;

			// speed of the particles
			double m_vitesse;

			// temp max number of particles
			int m_nombre_tot;

			// no of particles frequently displayed
			int m_nombre_actifs;
 			
			// temps for creation of new particle(s)
			int	m_temps_tot;
			int	m_temps;
			
			// no of particles emited in fact
			int m_nbr_emission;

			// default constructor
			effet_particule( double x, double y, double z, double vitesse, int nombre_tot , struct infos_gen * , int vitesse_emission , int nbr_emission );

			// default destructor
			~effet_particule( );
			
			// calculate position of the particles
			void calculer();
		
			// display particles
			void afficher();
};

#endif
